"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.payoutBatchItemCompositeKeyIsomorphism = exports.parser = exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs = exports.SEPARATOR = void 0;
const parsers_common_1 = require("./parsers.common");
const function_1 = require("fp-ts/function");
exports.SEPARATOR = ':';
const payoutBatchItemCompositeKeyIsomorphismFromParseArgs = (strict = true) => (serialized) => {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    const [userId, originType, currency, ...rest] = serialized.split(exports.SEPARATOR);
    if (strict && rest.length > 0)
        throw new Error(`invalid serialized PayoutBatchItemCompositeKey: ${serialized}; extra parts: ${rest.join(exports.SEPARATOR)}`);
    return {
        userId,
        originType,
        currency,
    };
};
exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs = payoutBatchItemCompositeKeyIsomorphismFromParseArgs;
exports.parser = parsers_common_1.payoutBatchItemCompositeKeyParser;
exports.payoutBatchItemCompositeKeyIsomorphism = {
    to: ({ userId, originType, currency }) => `${userId}${exports.SEPARATOR}${originType}${exports.SEPARATOR}${currency}`,
    from: (0, function_1.flow)((0, exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(true), exports.parser.parse),
};
